open Glfw

let r_run = ref true
let r_keyrepeat = ref false
let r_systemkeys = ref false

let key k p =
    let d s = Printf.printf "%s\n" s; flush stdout in
    if p then match k with
    | k when k = key_esc -> r_run := false; d "ESC => quit program"
    | k when k = key_f1 -> d "F1"
    | k when k = key_f2 -> d "F2"
    | k when k = key_f3 -> d "F3"
    | k when k = key_f4 -> d "F4"
    | k when k = key_f5 -> d "F5"
    | k when k = key_f6 -> d "F6"
    | k when k = key_f7 -> d "F7"
    | k when k = key_f8 -> d "F8"
    | k when k = key_f9 -> d "F9"
    | k when k = key_f10 -> d "F10"
    | k when k = key_f11 -> d "F11"
    | k when k = key_f12 -> d "F12"
    | k when k = key_up -> d "UP"
    | k when k = key_down -> d "DOWN"
    | k when k = key_left -> d "LEFT"
    | k when k = key_right -> d "RIGHT"
    | k when k = key_lshift -> d "LSHIFT"
    | k when k = key_rshift -> d "RSHIFT"
    | k when k = key_lalt -> d "LALT"
    | k when k = key_ralt -> d "RALT"
    | k when k = key_lctrl -> d "LCTRL"
    | k when k = key_rctrl -> d "RCTRL"
    | k when k = key_tab -> d "TAB"
    | k when k = key_backspace -> d "BACKSPACE"
    | k when k = key_insert -> d "INSERT"
    | k when k = key_del -> d "DEL"
    | k when k = key_pageup -> d "PAGEUP"
    | k when k = key_pagedown -> d "PAGEDOWN"
    | k when k = key_home -> d "HOME"
    | k when k = key_end -> d "END"
    | k when k = key_kp_0 -> d "KEYPAD 0"
    | k when k = key_kp_1 -> d "KEYPAD 1"
    | k when k = key_kp_2 -> d "KEYPAD 2"
    | k when k = key_kp_3 -> d "KEYPAD 3"
    | k when k = key_kp_4 -> d "KEYPAD 4"
    | k when k = key_kp_5 -> d "KEYPAD 5"
    | k when k = key_kp_6 -> d "KEYPAD 6"
    | k when k = key_kp_7 -> d "KEYPAD 7"
    | k when k = key_kp_8 -> d "KEYPAD 8"
    | k when k = key_kp_9 -> d "KEYPAD 9"
    | k when k = key_kp_divide -> d "KEYPAD DIVIDE"
    | k when k = key_kp_multiply -> d "KEYPAD MULTIPLY"
    | k when k = key_kp_subtract -> d "KEYPAD SUBTRACT"
    | k when k = key_kp_add -> d "KEYPAD ADD"
    | k when k = key_kp_decimal -> d "KEYPAD DECIMAL"
    | k when k = key_kp_enter -> d "KEYPAD ENTER"
    | k when k = key_space -> d "SPACE"
    | k when k = int_of_char 'R' -> 
	r_keyrepeat := not !r_keyrepeat;
	(if !r_keyrepeat then enable else disable) KEY_REPEAT;
	d ("R => Key repeat: "^string_of_bool !r_keyrepeat)
    | k when k = int_of_char 'S' -> 
	r_systemkeys := not !r_systemkeys;
	(if !r_systemkeys then enable else disable) SYSTEM_KEYS;
	d ("S => System keys: "^string_of_bool !r_systemkeys)
    | k -> Printf.printf "%c\n" (char_of_int k); flush stdout
    

let _ =
    try
	if not (init ()) then failwith "Glfw.init failed";
	if not (open_window 250 100 0 0 0 0 0 0 WINDOW) then failwith "Glfw.open_window failed";
	set_window_title "Press some keys!";
	set_key_cb key;
	let rec g () =
	    if not !r_run then () 
	    else begin
		Gl.glClearColor (0.5 +. 0.5 *. sin (3.0 *. Unix.gettimeofday ())) 0.0 0.0 0.0;
		Gl.glClear Gl.cgl_color_buffer_bit;
		swap_buffers ();
		r_run := !r_run && (get_window_param OPENED <> 0);
		g ();
	    end
	in
	g ();
	terminate ()
    with Failure s -> Printf.eprintf "Failure: %s\n" s
