open Glfw

let p d =
    Printf.printf "w:%i h:%i r:%i g:%i b:%i\n" d.vm_width d.vm_height d.vm_redbits d.vm_greenbits d.vm_bluebits

let _ =
    try
	if not (init ()) then failwith "Glfw.init failed";
	let a,b,c = get_version () in
	Printf.printf "GLFW version %i.%i.%i\n" a b c;
	let d = get_desktop_mode () in
	let da = get_video_modes () in
	Printf.printf "Current video mode: ";
	p d;
	Printf.printf "\nAvailable video modes:\n";
	Array.iter p da;
	terminate ()
    with Failure s -> Printf.eprintf "Failure: %s\n" s
