open Glfw
open Gl

let p d =
    Printf.printf "w:%i h:%i r:%i g:%i b:%i\n" d.vm_width d.vm_height d.vm_redbits d.vm_greenbits d.vm_bluebits

let _ =
    let quit s =
	Printf.printf s; flush stdout;
	closewindow ();
	terminate ();
	exit 0
    in
    if not (init ()) then quit "Glfw init != 0\n";
    let va,vb,vc = getversion () in
    let d = getdesktopmode () in
    let da = getvideomodes () in
    Printf.printf "version: %i.%i.%i\n" va vb vc;
    p d;
    Array.iter p da;
    if not (openwindow 0 0 0 0 0 8 0 0 WINDOW) then quit "openwindow failed\n";
    setwindowtitle "test window";
    let _ = (* window info *)
	let f a b = Printf.printf "%s: %i\n" a (getwindowparam b) in
	f "OPENED" OPENED;
	f "ACTIVE" ACTIVE;
	f "ICONIFIED" ICONIFIED;
	f "ACCELERATED" ACCELERATED;
	f "RED_BITS" RED_BITS;
	f "GREEN_BITS" GREEN_BITS;
	f "BLUE_BITS" BLUE_BITS;
	f "ALPHA_BITS" ALPHA_BITS;
	f "DEPTH_BITS" DEPTH_BITS;
	f "STENCIL_BITS" STENCIL_BITS;
	f "REFRESH_RATE" REFRESH_RATE;
	f "ACCUM_RED_BITS" ACCUM_RED_BITS;
	f "ACCUM_GREEN_BITS" ACCUM_GREEN_BITS;
	f "ACCUM_BLUE_BITS" ACCUM_BLUE_BITS;
	f "ACCUM_ALPHA_BITS" ACCUM_ALPHA_BITS;
	f "AUX_BUFFERS" AUX_BUFFERS;
	f "STEREO" STEREO;
	flush stdout;
    in
    let _ = (* Joystick test *)
	for i = 0 to 15 do
	    let b = getjoystickparam i PRESENT in
	    Printf.printf "joystick %i %i\n" i b
	done;
	flush stdout;
	let a = getjoystickpos 0 4 in
	Printf.printf "pos length: %i\n" (Array.length a); flush stdout;
	let a = getjoystickbuttons 0 4 in
	Printf.printf "buttons length: %i\n" (Array.length a); flush stdout;
    in
    let _ =
	let f x y = Printf.printf "x: %i y: %i\n" x y; flush stdout in
	setwindowsizecb f
    in
    while true do
	glClear cgl_color_buffer_bit;
	glRectf (-0.5) (-0.5) 0.5 0.5;
	swapbuffers ();
	pollevents ();
	if getkey key_esc then quit "normal quit\n";
	if getkey key_f1 then enable MOUSE_CURSOR;
	if getkey key_f2 then disable MOUSE_CURSOR;
    done


