open Gl

let draw () = 
    glClear (cgl_color_buffer_bit lor cgl_depth_buffer_bit);
    Glfw.swap_buffers ()

let reshape x y =
    glViewport 0 0 x y;
    glMatrixMode cgl_projection;
    glLoadIdentity ();
    glMatrixMode cgl_modelview;
    glLoadIdentity ()

let key k b = if b then match k with
| _ when k = Glfw.key_esc -> raise Exit
| _ -> ()

let _ =
    try
	if not (Glfw.init ()) then failwith "Glfw.init failed";
	if not (Glfw.open_window 800 600 0 0 0 8 24 8 Glfw.WINDOW) then failwith "open_window failed";
	Glfw.set_window_size_cb reshape;
	Glfw.set_key_cb key;
	while true do 
	    draw ();
	    if Glfw.get_window_param Glfw.OPENED = 0 then raise Exit;
	done
    with 
    | Failure s -> Printf.eprintf "Failure: %s\n" s
    | Exit -> Glfw.terminate ()
