open Gl

let _ =
    let has s =
	let es = glGetString cgl_extensions in
	let el = Str.split (Str.regexp "[ \t]+") es in
	List.mem s el
    in
    let ps ns n =
	let s = glGetString n in
	Printf.printf "%s: %s\n" ns s
    in
    let pi ns n =
	let i = Hgl.get_integer n in
	Printf.printf "%s: %i\n" ns i
    in
    let pf ns n =
	let i = Hgl.get_double n in
	Printf.printf "%s: %f\n" ns i
    in
    let pf2 ns n =
	let a = Hgl.ba_double 2 in
	glGetDoublev n a;
	Printf.printf "%s: %f,%f\n" ns a.{0} a.{1}
    in
    try
	if not (Glfw.init ()) then failwith "Glfw.init failed";
	if not (Glfw.open_window 0 0 0 0 0 0 0 0 Glfw.WINDOW) then failwith "open_window failed";
	(* Generic information *)
	ps "GL_VERSION" cgl_version;
	ps "GL_VENDOR" cgl_vendor;
	ps "GL_RENDERER" cgl_renderer;
	pi "GL_MAX_LIGHTS" cgl_max_lights;
	pi "GL_MAX_CLIP_PLANES" cgl_max_clip_planes;
	pi "GL_MAX_COLOR_MATRIX_STACK_DEPTH" cgl_max_color_matrix_stack_depth;
	pi "GL_MAX_MODELVIEW_STACK_DEPTH" cgl_max_modelview_stack_depth;
	pi "GL_MAX_PROJECTION_STACK_DEPTH" cgl_max_projection_stack_depth;
	pi "GL_MAX_TEXTURE_STACK_DEPTH" cgl_max_texture_stack_depth;
	pi "GL_SUBPIXEL_BITS" cgl_subpixel_bits;
	pi "GL_MAX_3D_TEXTURE_SIZE" cgl_max_3d_texture_size;
	pi "GL_MAX_TEXTURE_SIZE" cgl_max_texture_size;
	pf "GL_MAX_TEXTURE_LOD_BIAS" cgl_max_texture_lod_bias;
	pi "GL_MAX_CUBE_MAP_TEXTURE_SIZE" cgl_max_cube_map_texture_size;
	pi "GL_MAX_PIXEL_MAP_TABLE" cgl_max_pixel_map_table;
	pi "GL_MAX_NAME_STACK_DEPTH" cgl_max_name_stack_depth;
	pi "GL_MAX_LIST_NESTING" cgl_max_list_nesting;
	pi "GL_MAX_EVAL_ORDER" cgl_max_eval_order;
	pi "GL_MAX_VIEWPORT_DIMS" cgl_max_viewport_dims;
	pi "GL_MAX_ATTRIB_STACK_DEPTH" cgl_max_attrib_stack_depth;
	pi "GL_MAX_CLIENT_ATTRIB_STACK_DEPTH" cgl_max_client_attrib_stack_depth;
	pf2 "GL_ALIASED_POINT_SIZE_RANGE" cgl_aliased_point_size_range;
	pf2 "GL_SMOOTH_POINT_SIZE_RANGE" cgl_smooth_point_size_range;
	pf "GL_SMOOTH_POINT_SIZE_GRANULARITY" cgl_smooth_point_size_granularity;
	pf2 "GL_ALIASED_LINE_WIDTH_RANGE" cgl_aliased_line_width_range;
	pf2 "GL_SMOOTH_LINE_WIDTH_RANGE" cgl_smooth_line_width_range;
	pf "GL_SMOOTH_LINE_WIDTH_GRANULARITY" cgl_smooth_line_width_granularity;
	pi "GL_MAX_ELEMENTS_INDICES" cgl_max_elements_indices;
	pi "GL_MAX_ELEMENTS_VERTICES" cgl_max_elements_vertices;
	pi "GL_MAX_TEXTURE_UNITS" cgl_max_texture_units;
	pi "GL_NUM_COMPRESSED_TEXTURE_FORMATS" cgl_num_compressed_texture_formats;
	if has "GL_NV_vertex_array_range" then
	    pi "GL_MAX_VERTEX_ARRAY_RANGE_ELEMENT_NV" cgl_max_vertex_array_range_element_nv;
	    

(* Whatis: 
    POINT_SIZE_MIN, POINT_SIZE_MAX 	
*)
	Glfw.terminate ()
    with Failure s -> Printf.eprintf "Failure: %s\n" s
