open Gl

let a = Hgl.ba_float_init [|-0.5;-0.5|]
let b = Hgl.ba_float_init [|0.5;0.5|]
let draw () =
    glClear cgl_color_buffer_bit;
    glRectfv a b;
    Hgl.test_glerror "draw";
    Glfw.swap_buffers ()

let key a b = if b then match a with
| _ when a = Glfw.key_esc -> raise Exit
| _ ->()

let _ =
    try
	if not (Glfw.init ()) then failwith "Glfw.init failed";
	if not (Glfw.open_window 0 0 0 0 0 0 0 0 Glfw.WINDOW) then failwith "Glfw.open_window failed";
	Glfw.set_key_cb key;
	while true do
	    draw ();
	    if Glfw.get_window_param Glfw.OPENED = 0 then raise Exit
	done
    with 
    | Failure s -> prerr_endline ("Failure: "^s)
    | Exit -> Glfw.terminate ()

    